package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.qmth.distributed.print.business.bean.dto.ClientExamStudentDto;
import com.qmth.distributed.print.business.bean.dto.ClientExamTaskDto;
import com.qmth.distributed.print.business.bean.dto.ClientPrintTaskDto;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * @Date: 2021/4/20.
 */
public interface ClientService {
    IPage<ClientExamTaskDto> listTryTask(Long schoolId, String machineCode, Long orgId, Long printPlanId, String courseCode, String paperNumber, Boolean isTry, Boolean isPass, Integer pageNumber, Integer pageSize);

    Map<String, String>  getUrl(Long schoolId, Long examTaskId);

    Boolean tagPass(Long schoolId, String courseCode, String courseName, String paperNumber, String machineCode, Boolean isPass, Long userId);

    Boolean updatePrintProgress(Long schoolId, Long examDetailId, Integer printProgress);

    IPage<ClientExamStudentDto> listStudent(Long schoolId, Long examDetailId, String ticketNumber, String studentName, String courseCode, Integer pageNumber, Integer pageSize);

    Map<String, Object> getReprintData(Long schoolId, Long examDetailId, String ticketNumber, String type);

    IPage<ClientPrintTaskDto> listClientPrintTask(Long schoolId, Long machineCode, String orgId, String printPlanId, String status, String courseCode, String paperNumber, String examPlace, String examRoom, Long examStartTime, Long examEndTime, Boolean isDownload, Boolean validate, Integer pageNumber, Integer pageSize);

    Map<String, Object> getPrintData(Long schoolId, Long examDetailId, String machineCode, String printUser);

    List<Map<String, Object>> getPrintDataBatch(Long schoolId, Long machineCode, String orgId, String printPlanId, String status, String courseCode, String paperNumber, String examPlace, String examRoom, Long examStartTime, Long examEndTime, Boolean isDownload, Boolean validate);

    Map<String, String> getUrlByExamDetailId(Long schoolId, Long examDetailId);

    Boolean updateDownload(Long schoolId, Long examDetailId, String machineCode, Boolean isDownload);

    Boolean validateData(Long schoolId, Long examDetailId, String packageCode, String lastCode);

    List<Map<String, String>> getBatchUrl(Long schoolId, String machineCode, Long orgId, Long printPlanId, String courseCode, String paperNumber, Boolean isTry, Boolean isPass);

    List<ClientPrintTaskDto> listClientPrintTask(HttpServletResponse response, Long schoolId, Long machineCode, String orgId, String printPlanId, String status, String courseCode, String paperNumber, String examPlace, String examRoom, Long examStartTime, Long examEndTime, Boolean isDownload, Boolean validate);
}
